<template>
  <v-container>
    <v-row>
      <v-col>
        <h2>Edit circle</h2>
        <p
          v-if="$store.state.circle.AddCircleStatus === 'success'"
          style="color: green;"
        >
          Success
        </p>
        <p v-if="$store.state.circle.AddCircleStatus === 'loading'">
          Loading...
        </p>
        <p
          v-if="$store.state.circle.AddCircleStatus === 'error'"
          style="color: red;"
        >
          {{ $store.state.circle.AddCircleErrorMessage }}
        </p>
      </v-col>
    </v-row>
    <v-form ref="form" v-model="valid">
      <v-row>
        <v-col sm="12" md="8">
          <v-row align="center">
            <v-col sm="12" md="4" offset-md="4">
              <image-upload
                :initial-image="editCircle.imageUrl"
                :path="'circles'"
                :type="'circle'"
                :circle-id="editCircle.id"
              />
            </v-col>
          </v-row>
          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Video Type</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="editCircle.videoType"
                dense
                :items="['zoom', 'google hangouts', 'private video url']"
                :rules="rules"
                outlined
                label="Video type"
                hide-details
                required
              />
            </v-col>
          </v-row>

          <v-row>
            <v-col xs="12" md="3">
              <v-label>Video meeting url</v-label>
            </v-col>
            <v-col xs="12" md="8" sm="12" class="text-right">
              <v-text-field
                  v-model="editCircle.videoURL"
                  dense
                  :rules="rules"
                  outlined
                  :label="videoUrlLabel"
                  hide-details
                  required
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Circle Title</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="editCircle.title"
                dense
                :rules="rules"
                outlined
                label="My Circle"
                hide-details
                required
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Description</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-textarea
                v-model="editCircle.description"
                label="Description"
                outlined
                rows="3"
                hide-details
                dense
              />
            </v-col>
          </v-row>

          <v-divider class="my-4" />
          <p class="title">Date & Time</p>
          <p class="caption">
            The time you choose below will be used as the starting point<br />
            and automatically determine all further recurring sessions for one
            slot.
          </p>
          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>When</v-label>
            </v-col>
            <v-col xs="12" md="4">
              <date-picker
                v-if="editCircle.dateItem && editCircle.dateItem.date"
                :date="editCircle.dateItem.date"
              />
            </v-col>
            <v-col xs="12" md="4">
              <time-picker
                v-if="editCircle.dateItem && editCircle.dateItem.time"
                :time="editCircle.dateItem.time"
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Duration</v-label>
            </v-col>
            <v-col xs="12" md="3">
              <v-select
                v-if="editCircle.sessionDuration && editCircle.sessionDuration.hr"
                v-model="editCircle.sessionDuration.hr"
                :items="Array.from(Array(24).keys())"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
            <v-col xs="12" md="1">Hr</v-col>
            <v-col xs="12" md="3">
              <v-select
                v-if="editCircle.sessionDuration && editCircle.sessionDuration.min"
                v-model="editCircle.sessionDuration.min"
                :items="[0, 15, 30, 45]"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
            <v-col xs="12" md="1">min</v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Location</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-if="editCircle.dateItem && editCircle.dateItem.timeZone"
                :value="editCircle.dateItem.timeZone"
                :items="moment.tz.names()"
                outlined
                type="number"
                hide-details
                required
                dense
              />
            </v-col>
          </v-row>
          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Recurring group</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                  v-model="editCircle.recurringGroup"
                  :items="[
                  { text: 'Yes', value: true },
                  { text: 'No', value: false }
                ]"
                  outlined
                  hide-details
                  required
                  dense
              />
            </v-col>
          </v-row>

          <v-row v-if="recurringGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>Will meet for circle</v-label>
            </v-col>
            <v-col xs="12" md="1">Every</v-col>
            <v-col xs="12" md="3">
              <v-select
                  v-if="editCircle.frequency && editCircle.frequency.number"
                  v-model="editCircle.frequency.number"
                  :items="Array.from(Array(10).keys())"
                  :rules="rules"
                  outlined
                  type="number"
                  hide-details
                  required
                  dense
              />
            </v-col>
            <v-col xs="12" md="3">
              <v-select
                  v-if="editCircle.frequency && editCircle.frequency.type"
                  v-model="editCircle.frequency.type"
                  :items="['week', 'month']"
                  outlined
                  hide-details
                  required
                  dense
              />
            </v-col>
          </v-row>

          <v-row v-if="editCircle.recurringGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>This is indefinitely group</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                  v-model="editCircle.indefinitelyGroup"
                  :items="[
                  { text: 'Yes', value: true },
                  { text: 'No', value: false }
                ]"
                  outlined
                  hide-details
                  required
                  dense
              />
            </v-col>
          </v-row>

          <v-row v-if="!editCircle.indefinitelyGroup" align="center">
            <v-col xs="12" md="3">
              <v-label>Number of sessions</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                  v-model="editCircle.numberOfSessions"
                  label="Number Of sessions"
                  :rules="rules"
                  outlined
                  type="number"
                  hide-details
                  required
                  dense
              />
            </v-col>
          </v-row>

          <v-divider class="my-4" />
          <p class="title">Circle Information</p>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Circle type</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <circle-types-select
                :add-circle-type="type => editCircleType(type)"
                :circle-type="editCircle.circleType"
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Visibility</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-select
                v-model="editCircle.visibilityType"
                :items="visibilityTypes"
                label="Visibility"
                outlined
                item-text="type"
                item-value="value"
                hide-details
                required
                dense
              ></v-select>
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Number of participants</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="editCircle.numOfParticipants"
                label="Number of participants"
                outlined
                type="number"
                hide-details
                prepend-inner-icon="mdi-account-group-outline"
                required
                dense
              />
            </v-col>
          </v-row>

          <v-row align="center">
            <v-col xs="12" md="3">
              <v-label>Price</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-text-field
                v-model="editCircle.price"
                label="Price"
                outlined
                type="number"
                hide-details
                dense
                required
              />
            </v-col>
          </v-row>

          <v-row align="baseline">
            <v-col xs="12" md="3">
              <v-label>Tags</v-label>
            </v-col>
            <v-col xs="12" md="8">
              <v-combobox
                v-model="editCircle.labels"
                :items="labelsItems"
                chips
                clearable
                label="Add tags to your circle"
                multiple
                outlined
                hint="Help pepole to find you by adding tags"
              >
                <template v-slot:selection="{ attrs, item, select, selected }">
                  <v-chip
                    v-bind="attrs"
                    :input-value="selected"
                    close
                    @click="select"
                    @click:close="remove(item)"
                  >
                    <strong>{{ item }}</strong
                    >&nbsp;
                  </v-chip>
                </template>
              </v-combobox>
            </v-col>
          </v-row>

          <v-divider class="my-4" />
          <v-row v-if="triggeredUpdate && !valid">
            <v-col md="6" offset-md="3" style="color: red;">
              All fields must be set.
            </v-col>
          </v-row>

          <v-row>
            <v-col md="6" offset-md="3">
              <v-btn
                :loading="loading"
                block
                color="primary"
                outlined
                @click="triggerUpdateCircle()"
                >Update circle</v-btn
              >
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-form>
  </v-container>
</template>

<script>
import DatePicker from '@/components/Shared/UI/DatePicker'
import TimePicker from '@/components/Shared/UI/TimePicker'
import CircleTypesSelect from '@/components/Shared/UI/CircleTypesSelect'
import EventBus from '@/event-bus'
import { mapActions, mapState } from 'vuex'
import ImageUpload from '@/components/Shared/ImageUpload'

export default {
  name: 'FacilitatorDashboard',
  components: {
    TimePicker,
    DatePicker,
    CircleTypesSelect,
    ImageUpload
  },
  props: {},
  data: () => ({
    circleTypes: [
      { type: 'Council', value: 'council', id: 1 },
      { type: 'Group circle', value: 'group_circle', id: 2 },
      { type: 'Forum', value: 'forum', id: 3 },
      { type: 'The song of the heart', value: 'song_of_heart', id: 4 }
    ],
    visibilityTypes: [
      { type: 'Public', value: true, id: 1 },
      { type: 'Private', value: false, id: 2 }
    ],
    rules: [v => !!v || 'This input is required!'],
    rulesVisibility: [v => v != null || 'This input is required!'],
    visibilityType: null,
    labelsItems: ['love', 'Group support'],
    dateMenu: false,
    date: null,
    picker: false,
    time: null,
    dates: [],
    sessionDuration: null,
    title: null,
    circleType: null,
    numOfParticipants: null,
    price: null,
    description: '',
    valid: false,
    editCircle: {},
    loading: false,
    triggeredUpdate: false,
    recurringGroup: false,
    indefinitelyGroup: false,
    numberOfSessions: 0,
    frequency: {
      number: 1,
      type: 'week'
    }
  }),
  head() {
    return {
      title: {
        inner: 'Facilitator Dashboard'
      }
    }
  },
  computed: {
    ...mapState('circle', ['AddCircleStatus']),
    ...mapState('circle', ['circle']),
    videoUrlLabel() {
      return this.editCircle.videoURL && this.editCircle.videoURL === 'zoom'
          ? 'Please copy your zoom meeting url and paste it here.'
          : 'Paste your url here';
    }
  },
  watch: {
    circle: {
      handler(circle) {
        if (circle) {
          this.editCircle = circle
        }
      }
    }
  },
  beforeDestroy() {
    this.triggerSetAddCircleStatus('none')
  },
  created() {
    EventBus.$on('setDate', date => {
      if (date) {
        this.editCircle.dateItem.date = date
      }
    })
    EventBus.$on('setTime', time => {
      if (time) {
        this.editCircle.dateItem.time = time
      }
    })
  },
  beforeMount() {
    this.doGetCircle()
  },
  mounted() {},
  methods: {
    ...mapActions('circle', ['triggerSetAddCircleStatus', 'getCircle']),
    async doGetCircle() {
      await this.getCircle(this.$route.params.id)
    },
    triggerUpdateCircle() {
      this.triggeredUpdate = true
      if (this.$refs.form.validate() && this.valid) {
        this.loading = true
        this.triggerSetAddCircleStatus('loading')
        this.$store
          .dispatch('circle/updateCircle', this.editCircle)
          .then(() => (this.loading = false))
          .catch(() => (this.loading = false))
      }
    },
    editCircleType(circleType) {
      this.editCircle.circleType = circleType
    }
  }
}
</script>

<style lang="scss" scoped></style>
